package calc;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Stack;


public class Compiler extends Stack<Int_char>{
	Vector<Int_char> formula = new Vector<Int_char>();
	Vector<fraction> numbers = new Vector<fraction>();
	Vector<String> variables = new Vector<String>();
	private Hashtable<String, fraction> var;
	private Stack<fraction> param;
	private char[] st;
	private int index;
	private StringBuffer number;
	private StringBuffer variable;
	private char oper;
	private boolean error;
	private boolean run; 
	private int prevTypeLexem;
	private fraction result;
	private String funct_name;
	private String f_vars;
	
	public Compiler(Hashtable<String, fraction> x, Stack<fraction> y){
		var = x;
		param = y;
		f_vars = null;
		variable = new StringBuffer("");
		number = new StringBuffer("");
		prevTypeLexem = 0;
	}	
	private boolean is_symbol_vars(char x, boolean first){// = false
		boolean res =(('A' <= x && x <= 'Z') ||
					('a' <= x && x <= 'z'));//||
					//(x == '_'));
		if (!first && !res)
			res = ('0' <= x && x <= '9');
		return res;
	}
    private char GetLexem() {
    	while (index < st.length && (st[index] == ' ' || st[index] == '\t')) ++index;
    	if (index >= st.length){
    		prevTypeLexem = 0;
    		return 0;
    	}
    	if (st[index] == ';'){    	
    		return 0;
    	}
    	if (number.length() > 0)
    		number.delete(0, number.length());
    	if (variable.length() > 0)
    		variable.delete(0, variable.length());
    	if (index < st.length-1 && st[index] == '/' && st[index+1] == '*'){
    		index += 2;
    		while (index < st.length && st[index-2] == '*' && st[index-1] == '/')
    			++index;
    	}
    	if (st[index] >= '0' && st[index] <= '9'){
    		while (index < st.length && st[index] >= '0' && st[index] <= '9'){
    			number.append(st[index] - '0');
    			++index;    			
    		}
    		prevTypeLexem = 1;
    		return 1;
    	}
		if (is_symbol_vars(st[index],true)){
			variable.append(st[index++]);
			while(index < st.length && is_symbol_vars(st[index], false))
				variable.append(st[index++]);
			prevTypeLexem = 2;
    		return 2;
		}
    	oper = st[index];
    	if (oper == '-' && st[index+1] != '-' && (prevTypeLexem != 1 && prevTypeLexem != 2))
    		oper = '~';
    	if (oper == '-' && st[index+1] == '-' && prevTypeLexem == 2){
    		oper = 'd'; ++index;}//a--
    	if (oper == '-' && st[index+1] == '-' && prevTypeLexem != 2){
    		oper = 'f'; ++index;}//--a
    	if (oper == '+' && st[index+1] == '+' && prevTypeLexem == 2){
    		oper = 'i'; ++index;}//a++
    	if (oper == '+' && st[index+1] == '+' && prevTypeLexem != 2){
    		oper = 'o'; ++index;}//++a
    	if (index+1 < st.length && st[index+1] == '='){
    		switch(oper){
    			case '<': oper = 'l'; break;
    			case '>': oper = 'g'; break;
    			case '=': oper = 'e'; break;
    			case '!': oper = 'n'; break;
    		}
    		++index;
    	}
    	if (oper == '|' && st[index+1] == '|')
    		++index;
    	if (oper == '&' && st[index+1] == '&')
    		++index;
    	++index;
    	if (prevTypeLexem == 2 && oper == '('){
    		oper = 'r';
    		--index;
    	}
    	if (oper == ')')
    		prevTypeLexem = 2;
    	else 
    		prevTypeLexem = 5;
    	return 5;
    }
    public void SetAVars(String a){
    	if (a != null)
    		f_vars = new String(a);
    	else 
    		f_vars = new String("");
    }
	public void compile(String str, boolean runs) {
		formula.clear();
        numbers.clear();
		error = false;
		int positionN = 0;
		int positionV = 0;
		boolean ok = true;
        funct_name = null;
		result = new fraction(0,1);	
		
        if (!runs)
        	return;
        // razbor
        index = 0;
        st = str.toCharArray();
		char res = 0;		
        processSymbol('(');
        while ((res = GetLexem()) != 0){
        	switch(res){
        	case 1: numbers.add(0, new fraction(new bigNumber(number.toString()), bigNumber.one)); formula.add(0, new Int_char('@')); break;
        	case 2: variables.add(0, new String(variable)); formula.add(0, new Int_char('#')); break;
        	case 5: processSymbol(oper);
        	}
        }        
        processSymbol(')');
        if (formula.size() > 0)
			while (ok){
				positionN = 0;
				positionV = 0;
				ok = false;
				for(int i = 0; i < formula.size(); ++i){
					if (formula.elementAt(i).GetValue() == '@')	{
						result.SetValue(numbers.elementAt(positionN));
						++positionN;
					}
					if (formula.elementAt(i).GetValue() == '#')	{
						if (!var.containsKey(f_vars + variables.elementAt(positionV)))
							var.put(f_vars + variables.elementAt(positionV), new fraction(fraction.zer));
							result.SetValue(var.get(f_vars + variables.elementAt(positionV)));
						++positionV;					
					}
					if (formula.elementAt(i).GetValue() == '~'){
						numbers.elementAt(positionN).SetValue(numbers.elementAt(positionN).un_minus());
						formula.remove(i);
						ok = true;
						break;
					}
					if ((formula.elementAt(i).GetValue() == '!') && i < formula.size() - 1 &&
							formula.elementAt(i+1).GetValue() == '@') {
						result.SetValue(numbers.elementAt(positionN).negation());
						numbers.elementAt(positionN).SetValue(result);
						formula.remove(i);
						ok = true;
						break;					
					}
					if (((formula.elementAt(i).GetValue() == 'd') ||
							(formula.elementAt(i).GetValue() == 'f') ||
							(formula.elementAt(i).GetValue() == 'i') ||
							(formula.elementAt(i).GetValue() == 'o') ||
							(formula.elementAt(i).GetValue() == '!'))
							&& i < formula.size() - 1 &&
							formula.elementAt(i+1).GetValue() == '#') {
						if (!var.containsKey(f_vars + variables.elementAt(positionV)))
							var.put(f_vars + variables.elementAt(positionV), new fraction(fraction.zer));
						fraction temp_frac = var.get(f_vars + variables.elementAt(positionV));
						switch (formula.elementAt(i).GetValue()){
							case 'i': result.SetValue(temp_frac);temp_frac.SetValue(temp_frac.Add(fraction.one)); break;
							case 'o': temp_frac.SetValue(temp_frac.Add(fraction.one));result.SetValue(temp_frac); break;
							case 'd': result.SetValue(temp_frac);temp_frac.SetValue(temp_frac.Minus(fraction.one));break;
							case 'f': temp_frac.SetValue(temp_frac.Minus(fraction.one));result.SetValue(temp_frac);break;
						}
						numbers.add(positionN, new fraction(result));
						formula.remove(i);
						formula.elementAt(i).SetValue('@');
						ok = true;
						break;					
					}
					if (formula.elementAt(i).GetValue() != '@' &&
						i < formula.size() - 2 &&
						(formula.elementAt(i+1).GetValue() == '@' || formula.elementAt(i+1).GetValue() == '#') && 
						(formula.elementAt(i+2).GetValue() == '@' || formula.elementAt(i+2).GetValue() == '#')){
						fraction A = null;
						fraction B = null;
						int pos_V = 0;
						int pos_N = 0;
						if (formula.elementAt(i+1).GetValue() == '@'){
							B = numbers.elementAt(positionN);
							++pos_N;
						} else {
							if (var.containsKey(f_vars + variables.elementAt(positionV))){
								B = var.get(f_vars + variables.elementAt(positionV));
							} else {
								B = new fraction(0,1);
							}
							++pos_V;						
						}
						if (formula.elementAt(i+2).GetValue() == '@'){
							A = numbers.elementAt(positionN+pos_N);
							++pos_N;
						} else {
							if (var.containsKey(f_vars + variables.elementAt(positionV+pos_V))){
								A = var.get(f_vars + variables.elementAt(positionV+pos_V));
							} else {
								A = new fraction(0,1);
							}
							++pos_V;
						}
						// ==== A [-+*/] B ====
						switch (formula.elementAt(i).GetValue()){
							case '.': B.set_den_ten();result.SetValue(A.Add(B));break;
							case '_': result.SetValue(A.Del(B));break;
							case '+': result.SetValue(A.Add(B));break;
							case '-': result.SetValue(A.Minus(B));break;
							case '*': result.SetValue(A.Mult(B));break;
							case '/': result.SetValue(A.Del(B));break;
							case '^': result.SetValue(A.power(B));break;
							case '<': result.SetValue(A.le(B));break;
							case '>': result.SetValue(A.ge(B));break;
							case 'l': result.SetValue(A.lt(B));break;
							case 'g': result.SetValue(A.gt(B));break;
							case 'e': result.SetValue(A.eq(B));break;
							case 'n': result.SetValue(!A.eq(B));break;
							case '&': result.SetValue(A.and(B));break;
							case '|': result.SetValue(A.or(B));break;
							case ',': param.push(A); result.SetValue(B); break;
						}
						if (formula.elementAt(i).GetValue() == 'r'){
							funct_name = new String(variables.elementAt(positionV+pos_V-1));
							f_vars = new String("0~"+funct_name+"~");
							param.push(B);
							formula.clear();
							run = true;
							break;	
						}
						if (formula.elementAt(i).GetValue() == '='){
							result.SetValue(A.SetValue(B));
							var.put(variables.elementAt(positionV), new fraction(result));
						}
						switch (pos_N){
							case 0: numbers.add(positionN, new fraction(result)); break;
							case 2: numbers.remove(positionN);
							case 1: numbers.elementAt(positionN).SetValue(result);break;
						}
						switch (pos_V){
							case 2: variables.remove(positionV);
							case 1: variables.remove(positionV); break;
						}
						formula.remove(i);
						formula.remove(i+1);
						formula.elementAt(i).SetValue('@');
						ok = true;
						break;
					}
				}
			}
		if (formula.size() > 1)
			error = true;
	}
    public fraction GetResult(){
    	return result;
    }
    public String GetFuncton(){
    	return funct_name;
    }
    public boolean isError(){
		return error;
	}
    public boolean isRun(){
    	if (run){
    		run = false;
    		return true;
    	}
    		return false;
	}
	public String toString(){
		StringBuffer result = new StringBuffer();
		int positionN = 0;
		int positionF = 0;
		int positionV = 0;
		int formula_size = formula.size();
		while (positionF < formula_size){
			result.append(' ');
			switch (formula.elementAt(positionF).GetValue()){
			case '@': result.append(numbers.elementAt(positionN++)); break;
			case '#': result.append(variables.elementAt(positionV++)); break;
			default : result.append((char)(formula.elementAt(positionF).GetValue())); break;
        	}
        	++positionF;
        }		
		return result.toString();
	}
    private void processSymbol(char c) {
        switch (c) {
          case '(': push(new Int_char(c)); break;
          case ')': processSuspendedSymbols(c); pop(); break;
          case '.': case '_': case '~': case '^':
          case 'd': case 'f': case 'i': case 'o':
          case '+': case '-': case '*': case '/':          
          case 'l': case 'g': case 'e': case 'n':
          case '&': case '|': case '>': case '<':
          case ',': case 'r':
          case '=': processSuspendedSymbols(c); push(new Int_char(c)); break;
        }
    }
    private void processSuspendedSymbols(char c) {
    	while (precedes(peek(), c))
    		formula.add(0, new Int_char(pop()));
    }
    private int priority(char c) {
    	int priorit = 0;
    	if (c == ',') priorit = 2;
    	if (c == '=') priorit = 3;
    	if (c == '&' || c == '|') priorit = 4;
    	if (c == 'e' || c == 'n') priorit = 5; // == !=
    	if (c == 'l' || c == 'g') priorit = 5; // <= >=
        if (c == '<' || c == '>') priorit = 5;
        if (c == '+' || c == '-') priorit = 6;
        if (c == '*' || c == '/') priorit = 10;
        if (c == '^') priorit = 11;
        if (c == 'd' || c == 'f') priorit = 12; // ++
        if (c == 'i' || c == 'o') priorit = 12; // --
        if (c == '.') priorit = 13;
        if (c == '_') priorit = 14;
        if (c == '~' || c == '!') priorit = 15;
        if (c == 'r') priorit = 16;
        return priorit;
    }
    private boolean precedes(Int_char a, char b) {
        if(a.GetValue() == '(') return false;
        if(b == ')') return true;
        if (a.GetValue() == b)
        	if (b == '=' || b == '^')
        		return false;
        return priority((char) a.GetValue()) >= priority(b);
    }
 }