package calc;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;
import java.util.Vector;

import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.tree.DefaultMutableTreeNode;

class Project extends JScrollPane{
	private Compiler compiler;
	protected command Command;
	private JTextArea TA;
	private String label;
	private String Path;
	private boolean isSave;
	private boolean isHelp;
	
	public Project(){
		TA = new JTextArea(20,40);
		Command = new command();
		compiler = new Compiler(Command.m_vars, Command.param);
		setViewportView(TA);
		Path = null;
		label = null;
		isSave = true;
		isHelp = false;
	}
	public DefaultMutableTreeNode getVarTree(){
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Variables");
		Enumeration e = Command.m_vars.keys();
		while (e.hasMoreElements())
			root.add(new DefaultMutableTreeNode(e.nextElement()));
		return root;
	}
	public DefaultMutableTreeNode getFunTree(){
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Function");
		Enumeration e = Command.functions.keys();
		while (e.hasMoreElements())
			root.add(new DefaultMutableTreeNode(e.nextElement()));
		return root;
	}
	public void Addline(String x){
		if (!isHelp)
			Command.addLine(x, -1);
		isSave = false;
	}
	public String Run(){
		isSave = false;
		if (isHelp)
			return "";
		return Command.Run();
	}
	public String GlobalRun(){
		isSave = false;
		Command.Clear();
		StringBuffer buffer = new StringBuffer(TA.getText() + "\n");
		if (isHelp)
			return "";
		Command.addLine(buffer.toString(), -1);
		return Command.Run();
	}
	public void Help(){
		TA.removeAll();
		try {
			FileInputStream fis = new FileInputStream("fraccalc.texi");
			File fileinfo = new File("fraccalc.texi");
			int file_size = (int) fileinfo.length();
			byte[] buffer = new byte[file_size];
			fis.read(buffer, 0, file_size);
			TA.append(new String(buffer));
			fis.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		isSave = true;
		isHelp = true;
	}
	public void LoadFile(File file){
		TA.removeAll();
		try {
			FileInputStream fis = new FileInputStream(file);
			File fileinfo = new File(file.getAbsolutePath());
			int file_size = (int) fileinfo.length();
			byte[] buffer = new byte[file_size];
			fis.read(buffer, 0, file_size);
			TA.append(new String(buffer));
			fis.close();
			label = new String(file.getName());
			Path = new String(file.getAbsolutePath());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		isSave = true;
	}
	public void SaveFile(File file){
		if (file != null){
			Path = new String(file.getAbsolutePath());
			label = new String(file.getName());
		}
		try {
			FileOutputStream fis = new FileOutputStream(Path);
			fis.write(TA.getText().getBytes());
			fis.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		isSave = true;
	}
	public String getLabel(){
		if (label == null)
			return "untitled";
		return label;
	}
	public String getPath(){
		return Path;	
	}
	public boolean isSaved(){
		return isSave;
	}
	public boolean isPath(){
		return Path != null;
	}
}