public void compile(String str, boolean run) {
	formula.clear();
        numbers.clear();
        index = 0;
        if (!run)
        	return;
		st = str.toCharArray();
		char res = 0;		
        processSymbol('(');
        while ((res = GetLexem()) != 0){
        	switch(res){
        	case 1: numbers.add(0, new fraction(new bigNumber(number.toString()), bigNumber.one)); formula.add(0, new Int_char('@')); break;
        	case 2: variables.add(0, new String(variable)); formula.add(0, new Int_char('#')); break;
        	case 5: processSymbol(oper);
        	}
        }        
        processSymbol(')');
    }
private void processSymbol(char c) {
        switch (c) {
          case '(': push(new Int_char(c)); break;
          case ')': processSuspendedSymbols(c); pop(); break;
          case '.': case '_': case '~': case '^':
          case 'd': case 'f': case 'i': case 'o':
          case '+': case '-': case '*': case '/':          
          case 'l': case 'g': case 'e': case 'n':
          case '&': case '|': case '>': case '<':
          case '=': processSuspendedSymbols(c); push(new Int_char(c)); break;
        }
    }
private void processSuspendedSymbols(char c) {
    	while (precedes(peek(), c))
    		formula.add(0, new Int_char(pop()));
    }
private int priority(char c) {
    	int priorit = 0;
    	if (c == '=') priorit = 1;
    	if (c == '&' || c == '|') priorit = 2;
    	if (c == 'e' || c == 'n') priorit = 3; // == !=
    	if (c == 'l' || c == 'g') priorit = 3; // <= >=
        if (c == '<' || c == '>') priorit = 3;
        if (c == '+' || c == '-') priorit = 4;
        if (c == '*' || c == '/') priorit = 5;
        if (c == '^') priorit = 9;
        if (c == 'd' || c == 'f') priorit = 10; // ++
        if (c == 'i' || c == 'o') priorit = 10; // --
        if (c == '.') priorit = 11;
        if (c == '_') priorit = 12;
        if (c == '~' || c == '!') priorit = 13;
        return priorit;
    }
private boolean precedes(Int_char a, char b) {
        if(a.GetValue() == '(') return false;
        if(b == ')') return true;
        return priority((char) a.GetValue()) >= priority(b);
    }
 }