package calc;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.math.BigInteger;
import java.rmi.activation.ActivationGroupDesc.CommandEnvironment;
import java.util.Date;
import java.util.Vector;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.tree.DefaultMutableTreeNode;

public class fraccalc extends JFrame{
	Compiler compiler;
	command Command;
    public static void main(String[] args) throws Exception {
  	    fraccalc win = new fraccalc("FracCalc");
     	win.setVisible(true);     	
    }
	public fraccalc(String title){
		super(title);
		Command = new command();
		compiler = new Compiler(Command.m_vars, Command.param);
		setBackground(Color.WHITE);
		setBounds(100,50,800,680);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		Container con = getContentPane();
		con.setLayout(new BorderLayout());
		
		JMenuBar lMenu = new JMenuBar();
		setJMenuBar(lMenu);
		JMenu FileMenu = new JMenu("File");
		lMenu.add(FileMenu);
		JMenuItem fnew = new JMenuItem("New");
		FileMenu.add(fnew);
		JMenuItem m_open = new JMenuItem("Open");
		FileMenu.add(m_open);
		JMenuItem m_save = new JMenuItem("Save");
		FileMenu.add(m_save);
		JMenuItem m_save_as = new JMenuItem("Save As...");
		FileMenu.add(m_save_as);
		JMenuItem m_close = new JMenuItem("Close");
		FileMenu.add(m_close);
		FileMenu.addSeparator();
		JMenuItem m_exit = new JMenuItem("Exit");
		FileMenu.add(m_exit);
		m_exit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}			
		});
		JMenu m_Run = new JMenu("Run");
		lMenu.add(m_Run);
		JMenuItem m_run = new JMenuItem("Run");
		m_Run.add(m_run);
		JMenu m_Help = new JMenu("Help");
		lMenu.add(m_Help);
		JMenuItem m_about = new JMenuItem("About");
		m_Help.add(m_about);
		
		JToolBar bar = new JToolBar();
		JButton b_new = new JButton(new ImageIcon("image/new.gif"));
		JButton b_open = new JButton(new ImageIcon("image/open.gif"));
		JButton b_save = new JButton(new ImageIcon("image/save.gif"));
		JButton b_close = new JButton(new ImageIcon("image/close.gif"));
		JButton b_run = new JButton(new ImageIcon("image/run.gif"));
		JButton b_help = new JButton(new ImageIcon("image/help.gif"));
		bar.add(b_new);
		bar.add(b_open);
		bar.add(b_save);
		bar.add(b_close);
		bar.addSeparator();
		bar.add(b_run);
		bar.addSeparator();
		bar.add(b_help);		
		bar.setBorder(BorderFactory.createEtchedBorder());
		con.add(bar, BorderLayout.NORTH);
		
		JPopupMenu popup = new JPopupMenu();
		popup.add(fnew);
		
		JTextArea consol = new JTextArea(5,50);
		JScrollPane SPD = new JScrollPane(consol);
		SPD.setBorder(BorderFactory.createMatteBorder(3, 3, 3, 3, Color.LIGHT_GRAY));
		SPD.setColumnHeaderView(new JLabel("Output:"));
		SPD.setAutoscrolls(true);
		
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("root");
		JTree tree = new JTree(root);
		JScrollPane SPL = new JScrollPane(tree);
		SPL.setBorder(BorderFactory.createMatteBorder(3, 3, 3, 3, Color.LIGHT_GRAY));
		SPL.setColumnHeaderView(new JLabel("OutLine:"));
		con.add(SPL, BorderLayout.EAST);		
		
		
		final JPanel p_main = new JPanel();
		final CardLayout cl = new CardLayout();
		p_main.setLayout(cl);
		
		JPanel p_one = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints c =  new GridBagConstraints();
		c.anchor = GridBagConstraints.NORTH; 
		c.fill   = GridBagConstraints.NONE;  
		c.gridheight = 1;
		c.gridwidth  = GridBagConstraints.REMAINDER; 
		c.gridx = GridBagConstraints.RELATIVE; 
		c.gridy = GridBagConstraints.RELATIVE; 
		c.insets = new Insets(40, 0, 0, 0);
		c.ipadx = 0;
		c.ipady = 0;
		c.weightx = 0.0;
		c.weighty = 0.0;
		p_one.setLayout(gbl);
				
		JPanel p_button = new JPanel();
		p_button.setLayout(new GridLayout(4,1,15,15));
		p_button.setBackground(Color.WHITE);
		JButton pb_new = new JButton("New", new ImageIcon("image/new.gif"));
		JButton pb_open = new JButton("Open", new ImageIcon("image/open.gif"));
		JButton pb_close = new JButton("Close", new ImageIcon("image/close.gif"));
		JButton pb_help = new JButton("Help", new ImageIcon("image/help.gif"));
		pb_new.setPreferredSize(new Dimension(250,50));
		pb_open.setPreferredSize(new Dimension(250,50));
		pb_close.setPreferredSize(new Dimension(250,50));
		pb_help.setPreferredSize(new Dimension(250,50));
		p_button.add(pb_new);
		p_button.add(pb_open);
		p_button.add(pb_close);
		p_button.add(pb_help);

		JLabel label1 = new JLabel("<html><font color=\"red\">F</font>rac<font color=\"red\">C</font>alc", JLabel.LEFT);
		label1.setFont(new Font("MonoSpaced", Font.ITALIC | Font.BOLD, 34));
		JLabel label2 = new JLabel("an exact precision calculator language", JLabel.LEFT);
		label2.setFont(new Font("TimesRoman", Font.ITALIC, 16));
		label1.setPreferredSize(new Dimension(580,35));
		label2.setPreferredSize(new Dimension(580,25));

		c.insets = new Insets(5, 0, 0, 0);
		p_one.add(label1, c);
		c.insets = new Insets(5, 0, 0, 0);
		p_one.add(label2, c);
		c.insets = new Insets(45, 0, 0, 0);
		p_one.add(p_button, c);
		
		p_one.setBackground(Color.WHITE);
		p_one.setBorder(BorderFactory.createEtchedBorder(Color.green, Color.blue));
		p_main.add(p_one, "one");
		
		JPanel p_two = new JPanel();
		p_two.setLayout(new BorderLayout());
		final myTabbed Tabbed = new myTabbed(JTabbedPane.TOP, JTabbedPane.SCROLL_TAB_LAYOUT, consol, root, tree);
		JTextField TF = new JTextField(35);
		Tabbed.setBorder(BorderFactory.createMatteBorder(3, 3, 3, 3, Color.LIGHT_GRAY));
		TF.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
		TF.setBorder(BorderFactory.createMatteBorder(0, 3, 3, 3, Color.LIGHT_GRAY));
		p_two.add(Tabbed, BorderLayout.CENTER);
		p_two.add(TF, BorderLayout.SOUTH);		
		
		p_main.add(p_two, "two");
		
		JSplitPane JSP = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, SPL, p_main);
		JSP.setDividerLocation(150);
		JSplitPane JSP2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, JSP, SPD);
		con.add(JSP2, BorderLayout.CENTER);
		
		// Events
		TF.addKeyListener(new TextEvent(TF, Tabbed));
		fnew.addActionListener(new newFile(Tabbed));
		m_about.addActionListener(new Help(Tabbed));
		m_open.addActionListener(new Open(Tabbed));
		m_save.addActionListener(new Save(Tabbed, false, false));
		m_save_as.addActionListener(new Save(Tabbed, true, false));
		m_close.addActionListener(new Save(Tabbed, true, true));
		m_run.addActionListener(new Run(Tabbed));
		b_new.addActionListener(new newFile(Tabbed));
		b_open.addActionListener(new Open(Tabbed));
		b_save.addActionListener(new Save(Tabbed, true, false));
		b_close.addActionListener(new Save(Tabbed, true, true));
		b_run.addActionListener(new Run(Tabbed));
		b_help.addActionListener(new Help(Tabbed));
		pb_new.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				p_main.getAlignmentX();
				cl.show(p_main, "two");
				newFile temp = new newFile(Tabbed);
				temp.actionPerformed(e);
			};			
		});
		pb_open.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				p_main.getAlignmentX();
				cl.show(p_main, "two");
				Open temp = new Open(Tabbed);
				temp.actionPerformed(e);
			};			
		});
		pb_close.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			};			
		});
		pb_help.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				p_main.getAlignmentX();
				cl.show(p_main, "two");
				Help temp = new Help(Tabbed);
				temp.actionPerformed(e);
			};			
		});
	}

	class newFile implements ActionListener{
		private myTabbed JTP;
		public newFile(myTabbed a){
			JTP = a;
		}
		public void actionPerformed(ActionEvent e) {
			JTP.add();
		}
	}
	class Help implements ActionListener{
		private myTabbed JTP;
		public Help(myTabbed a){
			JTP = a;
		}
		public void actionPerformed(ActionEvent e) {
			JTP.Help();
		}
	}
	class Run implements ActionListener{
		private myTabbed JTP;
		public Run(myTabbed a){
			JTP = a;
		}
		public void actionPerformed(ActionEvent e) {
			JTP.Run();
		}
	}
	class Open implements ActionListener{
		private myTabbed JTP;
		private JFileChooser fch;
		public Open(myTabbed a){
			JTP = a;
			fch = new JFileChooser();
			fch.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		}
		public void actionPerformed(ActionEvent e) {
			switch(fch.showDialog(null, "Open File...")){
				case JFileChooser.APPROVE_OPTION:
					JTP.LoadFile(fch.getSelectedFile());
					break;
				case JFileChooser.CANCEL_OPTION:
					break;
				case JFileChooser.ERROR_OPTION:
					break;
			}
			
		}
	}
	class Save implements ActionListener{
		private myTabbed JTP;
		private JFileChooser fch;
		private boolean as;
		private boolean close;
		public Save(myTabbed a, boolean _as, boolean _close){
			JTP = a;
			as = _as;
			close = _close;
			fch = new JFileChooser();
			fch.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		}
		public void actionPerformed(ActionEvent e) {
			boolean dialog = !JTP.isPath();
			if (!JTP.isSave()){
				if (as || dialog){
					switch(fch.showSaveDialog(null)){
						case JFileChooser.APPROVE_OPTION:
							JTP.SaveFile(fch.getSelectedFile());
							break;
						case JFileChooser.CANCEL_OPTION:
								break;
						case JFileChooser.ERROR_OPTION:
							break;
					}
				} else {
					JTP.SaveFile(null);
				}
			}
			if (close)
				JTP.Close();
		}
	}
	
	class TextEvent implements ActionListener, KeyListener{
		private JTextField TF;
		private Vector<String> history = new Vector<String>();
		private myTabbed JTP;
		private int index = 0;
		private boolean insert = true;
		
		public TextEvent(JTextField x, myTabbed y){
			TF = x;
			JTP = y;
		}	
		
		public void actionPerformed(ActionEvent e) {}
		public void keyPressed(KeyEvent e) {
			switch (e.getKeyCode()){
				case KeyEvent.VK_ENTER:
					String temp = new String(TF.getText() + "\n"); 
					JTP.Addline(temp);
					if (insert && !temp.equals(""))
						history.add(new String(temp));
					if (history.size() >= 15)
						history.remove(0);
					index = history.size();
					TF.setText("");
					break;
				case KeyEvent.VK_UP:
					insert = false;
					if(index > 0)
						--index;
					if (index < history.size() && index >= 0) TF.setText(history.get(index));				
					break;
				case KeyEvent.VK_DOWN:
					insert = false;
					if(index < history.size())
						++index;
					if (index < history.size()) 
						TF.setText(history.get(index));	
					else
						TF.setText("");
					break;
				case KeyEvent.VK_LEFT: break;
				case KeyEvent.VK_RIGHT: break;
				default:insert = true; break;
			}
		}
		public void keyReleased(KeyEvent e) {}
		public void keyTyped(KeyEvent e) {}
	}

}